max_args = 4                         # the maximum number of parameters to be processed

print """#ifndef AS_GEN_WRAPPER_H
#define AS_GEN_WRAPPER_H

#include "angelscript.h"
#include <new>

namespace gw {

template <typename T> class Proxy {
  public:
    T value;
    Proxy(T value) : value(value) {}
    static T cast(void * ptr) {
      return reinterpret_cast<Proxy<T> *>(&ptr)->value;
    }
  private:
    Proxy(const Proxy &);
    Proxy & operator=(const Proxy &);
};

template <typename T> struct Wrapper {};
template <typename T> struct ObjFirst {};
template <typename T> struct ObjLast {};
"""

typename_list = "typename A0"
type_list = "A0"
arg_list = "\n        static_cast<Proxy <A0> *>(gen->GetAddressOfArg(0))->value"
new_exp = "new (gen->GetAddressOfReturnLocation()) Proxy<R>"
obj_exp = "static_cast<T *>(gen->GetObject())->*"
obj_arg_exp = "\n        Proxy<T>::cast(gen->GetObject())"

template = """template <{0}{1}>
struct {9}<{2} ({3}*)({7}){4}> {{
  template <{2} ({3}*fp)({7}){4}>
  static void f(AS_NAMESPACE_QUALIFIER asIScriptGeneric * gen) {{
    {5}(({6}fp)({8}));
  }}
}};
"""

print template.format("",                       "", "void", "",    "",       "",      "",      "void", "", "Wrapper")
print template.format("typename R",             "", "R",    "",    "",       new_exp, "",      "void", "", "Wrapper")
print template.format("typename T",             "", "void", "T::", "",       "",      obj_exp, "void", "", "Wrapper")
print template.format("typename T, typename R", "", "R",    "T::", "",       new_exp, obj_exp, "void", "", "Wrapper")
print template.format("typename T",             "", "void", "T::", " const", "",      obj_exp, "void", "", "Wrapper")
print template.format("typename T, typename R", "", "R",    "T::", " const", new_exp, obj_exp, "void", "", "Wrapper")

print template.format("typename T",             "", "void", "",    "",       "",      "",      "T",    obj_arg_exp, "ObjFirst")
print template.format("typename T, typename R", "", "R",    "",    "",       new_exp, "",      "T",    obj_arg_exp, "ObjFirst")
print template.format("typename T",             "", "void", "",    "",       "",      "",      "T",    obj_arg_exp, "ObjLast")
print template.format("typename T, typename R", "", "R",    "",    "",       new_exp, "",      "T",    obj_arg_exp, "ObjLast")

for i in range(0, max_args):
    print template.format("",                         typename_list, "void", "",    "",       "",      "",      type_list, arg_list, "Wrapper")
    print template.format("typename R, ",             typename_list, "R",    "",    "",       new_exp, "",      type_list, arg_list, "Wrapper")
    print template.format("typename T, ",             typename_list, "void", "T::", "",       "",      obj_exp, type_list, arg_list, "Wrapper")
    print template.format("typename T, typename R, ", typename_list, "R",    "T::", "",       new_exp, obj_exp, type_list, arg_list, "Wrapper")
    print template.format("typename T, ",             typename_list, "void", "T::", " const", "",      obj_exp, type_list, arg_list, "Wrapper")
    print template.format("typename T, typename R, ", typename_list, "R",    "T::", " const", new_exp, obj_exp, type_list, arg_list, "Wrapper")

    print template.format("typename T, ",             typename_list, "void", "", "", "",      "", "T, " + type_list, obj_arg_exp + "," + arg_list, "ObjFirst")
    print template.format("typename T, typename R, ", typename_list, "R",    "", "", new_exp, "", "T, " + type_list, obj_arg_exp + "," + arg_list, "ObjFirst")
    print template.format("typename T, ",             typename_list, "void", "", "", "",      "", type_list + ", T", arg_list + "," + obj_arg_exp, "ObjLast")
    print template.format("typename T, typename R, ", typename_list, "R",    "", "", new_exp, "", type_list + ", T", arg_list + "," + obj_arg_exp, "ObjLast")

    typename_list += ", typename A{0}".format(i + 1)
    type_list += ", A{0}".format(i + 1)
    arg_list += ",\n        static_cast<Proxy <A{0}> *>(gen->GetAddressOfArg({0}))->value".format(i + 1)

print """template <typename T>
struct Id {
  template <T fn_ptr> AS_NAMESPACE_QUALIFIER asSFuncPtr  f(void) { return asFUNCTION(&Wrapper<T>::template f<fn_ptr>); }
  template <T fn_ptr> AS_NAMESPACE_QUALIFIER asSFuncPtr of(void) { return asFUNCTION(&ObjFirst<T>::template f<fn_ptr>); }
  template <T fn_ptr> AS_NAMESPACE_QUALIFIER asSFuncPtr ol(void) { return asFUNCTION(&ObjLast<T>::template f<fn_ptr>); }
};

template <typename T>
Id<T> id(T fn_ptr) { return Id<T>(); }

#define WRAP_FN(name)             (::gw::id(name).f< name >())
#define WRAP_MFN(ClassType, name) (::gw::id(&ClassType::name).f< &ClassType::name >())
#define WRAP_OBJ_FIRST(name)      (::gw::id(name).of< name >())
#define WRAP_OBJ_LAST(name)       (::gw::id(name).ol< name >())

#define WRAP_FN_PR(name, Parameters, ReturnType)             asFUNCTION((::gw::Wrapper<ReturnType (*)Parameters>::f< name >))
#define WRAP_MFN_PR(ClassType, name, Parameters, ReturnType) asFUNCTION((::gw::Wrapper<ReturnType (ClassType::*)Parameters>::f< &ClassType::name >))
#define WRAP_OBJ_FIRST_PR(name, Parameters, ReturnType)      asFUNCTION((::gw::ObjFirst<ReturnType (*)Parameters>::f< name >))
#define WRAP_OBJ_LAST_PR(name, Parameters, ReturnType)       asFUNCTION((::gw::ObjLast<ReturnType (*)Parameters>::f< name >))

} // end namespace gw

#endif"""